function []=moveRobot(arm,kopf,Trafo,static,handl,Angle)
%%%%%%%%%% Figure Init
rad2deg=180/pi;
deg2rad=pi/180;

scale=1;%40;
displacement=0;%1200;

%    figure(111);
%   figRob=  figure('Position',[0,0,600,400],'Name','Robot',...
%       'papertype','a4letter');
%   clf;
%   title('7 DOF Arm + 1DOF Trunk');
%   xlabel('X')
%   ylabel('Y')
%   zlabel('Z')
%   axis([-600 1000 -200 1100 -200 700]);
%   axis('equal')
%   grid;
%   view(-160,10);
%   material metal;
%axis([0 60 0 30 -0 25]);
%axis([0 60 0 30 -0 20]);
jannis=0;
if jannis==1

    [xlabelString,xtick]=tickLabel(-1200,1200,40,100);
    [ylabelString,ytick]=tickLabel(-0,1600,40,100);
    [zlabelString,ztick]=tickLabel(-0,1000,40,100);


    set(gca,'Xticklabel',xlabelString,'Xtick',xtick);
    set(gca,'Yticklabel',ylabelString,'Ytick',ytick);
    set(gca,'Zticklabel',zlabelString,'Ztick',ztick);
end;
%  view(170,20);
%%%%%%%%%% Figure Init End


%%lfs Bezeichnet die Reihenfolge in der die Vertexe aus der Vertexmatrix
%zu den Seitenflaechen der Kuben zusammengesetzt werden
lfs=[1 2 6 5;2 3 7 6;3 4 8 7;4 1 5 8;1 2 3 4;5 6 7 8];

rack=1;						       %zusammengesetzt werden

%%%%%%%%%%%%%%%% Constants
rad2deg=180/pi;
C90=Cube(90,90,90);
C70=Cube(70,70,70);
%%%%%%%%%%%%%%%% Constants


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   HT: steht fuer Transformation unter verwendung von
%       homogenen Koordinaten
%
%   Kpf: steht fuer Kopf
%
%   Cube(laenge,breite,hoehe) ist eine Fuktion die die Vertexmatrix
%   eines Quaders erzeugt
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Setzen aller Winkel
pan=Angle(1); %Kopf
el=Angle(2);    %Kopf

th0=Angle(3); %Body

%Arm
th1=Angle(4)*rad2deg;
th2=Angle(5)*rad2deg;
th3=Angle(6)*rad2deg;
th4=Angle(7)*rad2deg;
th5=Angle(8)*rad2deg-90;
th6=Angle(9)*rad2deg;
th7=Angle(10)*rad2deg;

%Gripper auf/zu
grip=Angle(11);
%


%    pan=Angle(1);
%    el=Angle(2);
%    th0=Angle(3);
%    th1=Angle(4);
%    th2=Angle(5);
%    th3=Angle(6);
%    th4=Angle(7);
%    th5=Angle(8)-90;
%    th6=Angle(9);
%    th7=Angle(10);
%    grip=Angle(11);
%Setzen aller Winkel 
  %%%%%%%%%%%%%%%%%%%%%%%%%%%% 


  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %
  % Festlegung der initialen Konfiguration
  %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %Kopf Init
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%

  orientierung=-90;%0


%   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   %%% Transformationen 
%   kopf=struct('module',{},'frame',{},'cam',{});
%   arm=struct('trunk',{},'shoulder',{},'elbow',{},'hand',{},'gripper',{},'adapter',{});
%   static=struct('table',{},'stand',{});
%   Trafo=struct('kopf',{},'arm',{},'static',{});
%   handl=struct('kopf',{},'arm',{},'static',{},'Trafo',{});
  
  
  
  
  Trafo.kopf(1).frame=HomoTrans(0,40+460,0,orientierung+pan);%Obere Kopfplatte
  Trafo.kopf(2).frame=Trafo.kopf(1).frame*HomoTrans(50,50,0,0);         %Kamerahaltung rechts
  Trafo.kopf(3).frame=Trafo.kopf(1).frame*HomoTrans(-50,50,0,0);        %kamerahaltung links

  %sich drehendes Modul in der Mitte (des Amtec Handgelenks)
  Trafo.kopf(1).module=HomoTrans(0,500+60+5,0,orientierung+pan)*HomoTrans(0,0,-el,0);

  %Die drei aeuseren Platten des Handgelenks(unten, rechts, links)
  Trafo.kopf(4).frame=Trafo.kopf(1).module*HomoTrans(0,60+5,0,0);      %untere Platte
  Trafo.kopf(5).frame=Trafo.kopf(1).module*HomoTrans(150,30,0,0);      %rechte Platte
  Trafo.kopf(6).frame=Trafo.kopf(1).module*HomoTrans(-150,30,0,0);     %linke Platte

  %Kameras
  Trafo.kopf(1).cam=Trafo.kopf(1).module*HomoTrans(150,40,90,0);      %Kamera links
  Trafo.kopf(2).cam=Trafo.kopf(1).module*HomoTrans(-150,40,90,0);     %Kamera rechts

  %%%%%%%%%Stativ
  Trafo.static(1).stand=HomoTrans(0,490,0,orientierung)*HomoTrans(0,50,90,0);
  Trafo.static(2).stand=HomoTrans(0,250,0,orientierung)*HomoTrans(0,100,90,0);  


  %%% Transformationen Ende 
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % 
  % Berechnung der Vertizes der Kuben
  %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


  static(1).stand=Trafo.static(1).stand*Cube(10,90,200);
  static(2).stand=Trafo.static(2).stand*Cube(490,30,30);


  kopf(1).frame=Trafo.kopf(1).frame*Cube(70,110,5);
  kopf(2).frame=Trafo.kopf(2).frame*Cube(70,5,105);
  kopf(3).frame=Trafo.kopf(3).frame*Cube(70,5,105);

  kopf(1).module=Trafo.kopf(1).module*Cube(70,90,120);

  kopf(4).frame=Trafo.kopf(4).frame*Cube(70,370,10);
  kopf(5).frame=Trafo.kopf(5).frame*Cube(30,10,60);
  kopf(6).frame=Trafo.kopf(6).frame*Cube(30,10,60);

  kopf(1).cam=Trafo.kopf(1).cam*Cube(20,20,120);
  kopf(2).cam=Trafo.kopf(2).cam*Cube(20,20,120);


  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % 
  % Dartstellung der Patches des Kopfes
  %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%set(handl(1).fig);

  for i=1:6
    if i<2
      set(handl.kopf(i).module,'vertices',[(kopf(i).module(1,:)'+displacement)/scale kopf(i).module(2,:)'/scale ...
	    kopf(i).module(3,:)'/scale],'FaceColor','y');    
    end;
    if i<3
      set(handl.kopf(i).cam,'vertices',[(kopf(i).cam(1,:)'+displacement)/scale kopf(i).cam(2,:)'/scale ...
	    kopf(i).cam(3,:)'/scale],'FaceColor','r');      
      
      set(handl.static(i).stand,'vertices',[(static(i).stand(1,:)'+displacement)/scale static(i).stand(2,:)'/scale ...
	    static(i).stand(3,:)'/scale],'FaceColor','black');    
    end;
    
    if i < 5
      set(handl.kopf(i).frame,'vertices',[(kopf(i).frame(1,:)'+displacement)/scale kopf(i).frame(2,:)'/scale ...
	    kopf(i).frame(3,:)'/scale],'FaceColor','b');  
    end;

    if i >4
      set(handl.kopf(i).frame,'vertices',[(kopf(i).frame(1,:)'+displacement)/scale kopf(i).frame(2,:)'/scale ...
	    kopf(i).frame(3,:)'/scale],'FaceColor','g');  
    end;
  end;  
  %Kopf Init Ende
  %%%%%%%%%%%%%%%%%%%%%%%%%%%% 


  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % 
  % Initialisierung des Armes
  %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %
  %  Berechnung der Transformationen
  %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


  spiel=0.001;             %Spiel zwischen den Modulen

  dd_1=20;                 %Abstand zwischen dem Schultermodul und dem
  %ersten Oberarmmod

  dd_2=30;                 %Abstand zwischen dem Ellbogenmodul und dem
  %ersten Unterarmmodul

  %%%%% Rumpf			   
  Trafo.static(1).base=HomoTrans(0,90-25,0,0-90);        % static(1).base
  Trafo.arm(1).trunk=HomoTrans(0,220-45,0,0-90);   % Cube1
  Trafo.arm(2).trunk=HomoTrans(0,310-45,0,th0-90); % Cube2
 
  
%  Trafo.arm(2).trunk=HomoTrans(0,310-45,0,0); % Cube2 DLR
  %%%%% Rumpf			   
% fprintf('th0 = %f\n',th0);

  %%%%% Schulter
  
  Trafo.arm(1).shoulder=HomoTrans(0,400,0,0+180)*HomoTrans(0,0,0,th0);

%  Trafo.arm(2).shoulder=Trafo.arm(1).shoulder*HomoTrans(0,90+spiel,-90,th1);
  Trafo.arm(2).shoulder=Trafo.arm(1).shoulder*HomoTrans(0,90+spiel,-90,th1);

  Trafo.arm(3).shoulder=Trafo.arm(2).shoulder*HomoTrans(0,90+45,0,0);  
  Trafo.arm(4).shoulder=Trafo.arm(3).shoulder*HomoTrans(0,-90-spiel,90,th2);  


  %%%%% Oberarm
  Trafo.arm(5).shoulder=Trafo.arm(4).shoulder*HomoTrans(0,90,0,0)*HomoTrans(0,90+dd_1,-90,0);   
  Trafo.arm(6).shoulder=Trafo.arm(5).shoulder*HomoTrans(0,90+spiel,0,th3);  
  %%%%% Oberarm

  
  %%%%% Schulter    
  
  %%%%% Ellbogen
  Trafo.arm(1).elbow=Trafo.arm(6).shoulder*HomoTrans(0,80+45,0,0);    
  Trafo.arm(2).elbow=Trafo.arm(1).elbow*HomoTrans(0,70+spiel,90,th4);
  %%%%% Ellbogen

  %%%%% Unterarm
  Trafo.arm(1).hand=Trafo.arm(2).elbow*HomoTrans(0,-70,0,0)*HomoTrans(0,70+dd_2,-90,0);   
  Trafo.arm(2).hand=Trafo.arm(1).hand*HomoTrans(0,70+spiel,0,th5);  
  %%%%% Unterarm

  %%%%% Handgelenk  
  ...
  Trafo.arm(3).hand=Trafo.arm(2).hand*HomoTrans(0,90+15+35+0,0,0)*HomoTrans(0,0.5,th6,0);    
  Trafo.arm(4).hand=Trafo.arm(3).hand*HomoTrans(0,90+17.5+30,0,th7); ...
      
      
      Trafo.arm(5).hand=Trafo.arm(2).hand*HomoTrans(0,40+35,0,0);
      Trafo.arm(6).hand=Trafo.arm(2).hand*HomoTrans(50,90+35,0,0);  
      Trafo.arm(7).hand=Trafo.arm(2).hand*HomoTrans(-50,90+35,0,0);    

      %%%%% Handgelenk  

      %%%%%%Gripper
      Trafo.arm(1).gripper=Trafo.arm(3).hand*HomoTrans(0,75,0,0);   

      Trafo.arm(2).gripper=Trafo.arm(4).hand*HomoTrans(50-grip/2,85,0,0);  
      Trafo.arm(3).gripper=Trafo.arm(4).hand*HomoTrans(-50+grip/2,85,0,0);
      %%%%%%Gripper   

      %%%%%%Verbindungsbeschlaege
      % Schulter Oberarm
      % Ellbogen Unteram
      Trafo.arm(5).adapter=Trafo.arm(4).shoulder*HomoTrans(0,40,0,0)*HomoTrans(0,90,-90,0);
      Trafo.arm(6).adapter=Trafo.arm(2).elbow*HomoTrans(0,-30,0,0)*HomoTrans(0,70,-90,0); 
      %%%%%%Verbindungsbeschlaege

      %%%%%%Zwischenstuecke
      Trafo.arm(1).adapter=Trafo.arm(2).trunk*HomoTrans(0,67.5,0,0-90);
      Trafo.arm(2).adapter=Trafo.arm(2).shoulder*HomoTrans(0,67.5,0,0);
      Trafo.arm(3).adapter=Trafo.arm(6).shoulder*HomoTrans(0,67.5,0,0);  
      Trafo.arm(4).adapter=Trafo.arm(2).hand*HomoTrans(0,53.0,0,0);  
      %%%%%%Zwischenstuecke  

      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      %
      %  Ende berechnung der Transformationen
      %
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      %
      %  Berechnung der Vertexmatrizen
      %
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



      %%%%% Rumpf			   
      static(1).base=Trafo.static(1).base*Cube(90,90,130);
      arm(1).trunk=Trafo.arm(1).trunk*C90;
      arm(2).trunk=Trafo.arm(2).trunk*C90; 
      %%%%% Rumpf			   

      %%%%% Schulter
      arm(1).shoulder=Trafo.arm(1).shoulder*C90;
      arm(2).shoulder=Trafo.arm(2).shoulder*C90;

      arm(3).shoulder=Trafo.arm(3).shoulder*C90;
      arm(4).shoulder=Trafo.arm(4).shoulder*C90;
      %%%%% Schulter

      %%%%% Oberarm
      arm(5).shoulder=Trafo.arm(5).shoulder*C90;
      arm(6).shoulder=Trafo.arm(6).shoulder*C90;
      %%%%% Oberarm

      %%%%% Ellbogen
      arm(1).elbow=Trafo.arm(1).elbow*C70;
      arm(2).elbow=Trafo.arm(2).elbow*C70;
      %%%%% Ellbogen

      %%%%% Unterarm
      arm(1).hand=Trafo.arm(1).hand*C70;
      arm(2).hand=Trafo.arm(2).hand*C70;
      %%%%% Unterarm

      %%%%%Handgelenk
      arm(3).hand=Trafo.arm(3).hand*Cube(70,90,120);    
      arm(4).hand=Trafo.arm(4).hand*Cube(70,105,95);
      
      arm(5).hand=Trafo.arm(5).hand*Cube(70,100,5);
      arm(6).hand=Trafo.arm(6).hand*Cube(70,5,105);
      arm(7).hand=Trafo.arm(7).hand*Cube(70,5,105);

      %%%%%%%%%Handgelk

      %%%%%%%%Gripper
      arm(1).gripper=Trafo.arm(1).gripper*Cube(20,20,30);

      arm(2).gripper=Trafo.arm(2).gripper*Cube(30,10,70);
      arm(3).gripper=Trafo.arm(3).gripper*Cube(30,10,70);
      %%%%%%%%Gripper


      %%%%%%Zwischenstuecke  
      arm(1).adapter=Trafo.arm(1).adapter*Cube(70,70,45);
      arm(2).adapter=Trafo.arm(2).adapter*Cube(70,70,45);
      arm(3).adapter=Trafo.arm(3).adapter*Cube(70,70,45);
      arm(4).adapter=Trafo.arm(4).adapter*Cube(70,70,35);
      %%%%%%Zwischenstuecke  

      %%%%%% Beschlaege
      arm(5).adapter=Trafo.arm(5).adapter*Cube(10,90,90);
      arm(6).adapter=Trafo.arm(6).adapter*Cube(10,70,70);
      %%%%%% Beschlaege

      static(1).table=HomoTrans(0,-5,-0,0)*HomoTrans(450,0,-0,90)*Cube(1100,900,10);



      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      % Zeichnen der patches
      % des Armes

      
      
      
      for j=1:7      
	if j<2
	  set(handl.static(j).table,'vertices',[(static(j).table(1,:)'+displacement)/scale static(j).table(2,:)'/scale ...
		static(j).table(3,:)'/scale],'FaceColor','white');
	  
	  
	  set(handl.static(j).base,'vertices',[(static(j).base(1,:)'+displacement)/scale static(j).base(2,:)'/scale ...
		static(j).base(3,:)'/scale],'FaceColor','black');  
	end;
	
	if j<3
	  set(handl.arm(j).trunk,'vertices',[(arm(j).trunk(1,:)'+displacement)/scale arm(j).trunk(2,:)'/scale ...
		arm(j).trunk(3,:)'/scale],'FaceColor','b');  
	  
	  set(handl.arm(j).elbow,'vertices',[(arm(j).elbow(1,:)'+displacement)/scale arm(j).elbow(2,:)'/scale ...
		arm(j).elbow(3,:)'/scale],'FaceColor','y');        
	end;
	
	if j < 4
	  set(handl.arm(j).gripper,'vertices',[(arm(j).gripper(1,:)+displacement)'/scale arm(j).gripper(2,:)'/scale ...
		arm(j).gripper(3,:)'/scale],'FaceColor','black');  
	end;
	
	
	if j < 5
	  set(handl.arm(j).hand,'vertices',[(arm(j).hand(1,:)'+displacement)/scale arm(j).hand(2,:)'/scale ...
		arm(j).hand(3,:)'/scale],'FaceColor','y');  
	  
	  set(handl.arm(j).adapter,'vertices',[(arm(j).adapter(1,:)'+displacement)/scale arm(j).adapter(2,:)'/scale ...
		arm(j).adapter(3,:)'/scale],'FaceColor','m');      
	end;
	
	if j >4
	  set(handl.arm(j).hand,'vertices',[(arm(j).hand(1,:)'+displacement)/scale arm(j).hand(2,:)'/scale ...
		arm(j).hand(3,:)'/scale],'FaceColor','b');
	  if j <7
	    set(handl.arm(j).adapter,'vertices',[(arm(j).adapter(1,:)+displacement)'/scale arm(j).adapter(2,:)'/scale ...
		  arm(j).adapter(3,:)'/scale],'FaceColor','r');  	    
	  end;
	end;    
	
	if j<7
	  set(handl.arm(j).shoulder,'vertices',[(arm(j).shoulder(1,:)'+displacement)/scale arm(j).shoulder(2,:)'/scale ...
		arm(j).shoulder(3,:)'/scale],'FaceColor','y');  
	end;      

      end;
drawnow;	      


      % Zeichnen der patches
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      % 
      % Initialisierung des Armes Ende
      %
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%










%  
%  for_kin(Angle(4)*deg2rad,Angle(5)*deg2rad,Angle(6)*deg2rad,Angle(7)*deg2rad,Angle(8)*deg2rad,Angle(9)*deg2rad,Angle(10)*deg2rad,Angle(3)*deg2rad);
%  






