% function moveConditions(Pos,TaskAng,angPos,Angle,arm,kopf,Trafo,static,handl)

global oldPos;
global Pos;
global oldTaskAng;
rad2deg=180/pi;
deg2rad=pi/180;
ghandle=guihandles;


if get(ghandle.radiobutton2,'Value')==0
    rad2deg=180/pi;

TaskAng=zeros(1,4);

angPos=zeros(1,12);
oldAngPos=zeros(1,12);

Angle=zeros(1,12);
vel=zeros(1,12);

Pos(1)   =400.0;	     
Pos(2)   =400.0;	     
Pos(3)   =120.0;	     


TaskAng(1)   =0.0;
TaskAng(2)   =0.0;
TaskAng(3) =120;
[A.arm,A.kopf,A.Trafo,A.static,A.handl]=initRobot;

set(ghandle.figure1,'UserData',A);
set(ghandle.radiobutton2,'Value',1)
set(handles.popupmenu1,'Value',4);


    [Angle(4),Angle(5),Angle(6),Angle(7),Angle(8),Angle(9),Angle(10)]= ...
        inv_kin8(Pos(1),Pos(2),Pos(3),TaskAng(1),TaskAng(2),TaskAng(3), ...
        TaskAng(4));
    Angle(11)=0;

moveRobot(A.arm,A.kopf,A.Trafo,A.static,A.handl,Angle);


set(ghandle.slider1,'Value',Pos(1));% X
set(ghandle.slider2,'Value',Pos(2));% Y
set(ghandle.slider3,'Value',Pos(3));% Z
set(ghandle.edit1,'String',num2str(Pos(1)));% X
set(ghandle.edit2,'String',num2str(Pos(2)));% Y
set(ghandle.edit3,'String',num2str(Pos(3)));% Z


set(ghandle.slider4,'Value',TaskAng(1));%EEF - Phi
set(ghandle.slider5,'Value',TaskAng(2));%EEF - Theta
set(ghandle.slider7,'Value',TaskAng(3));%Elbow - Angle
set(ghandle.edit4,'String',num2str(TaskAng(1)));%EEF - Phi
set(ghandle.edit5,'String',num2str(TaskAng(2)));%EEF - Theta
set(ghandle.edit7,'String',num2str(TaskAng(3)));%Elbow - Angle


oldTaskAng=TaskAng;
oldPos=Pos;

end;

ing_Pos=zeros(1,3);
ing_TaskAng=zeros(1,4);


bodyV=get(ghandle.radiobutton1,'Value');

TimeMenu=get(ghandle.popupmenu1,'Value');
timeStepArray=[1;5;10;20;50;100];
timestep=timeStepArray(TimeMenu);


Pos(1)=get(ghandle.slider1,'Value');% X
Pos(2)=get(ghandle.slider2,'Value');% Y
Pos(3)=get(ghandle.slider3,'Value');% Z


TaskAng(1)=get(ghandle.slider4,'Value');%EEF - Phi
TaskAng(2)=get(ghandle.slider5,'Value');%EEF - Theta
TaskAng(3)=get(ghandle.slider7,'Value');%Elbow - Angle
TaskAng(4)=get(ghandle.slider8,'Value');%Body - Angle

Gamma=get(ghandle.slider6,'Value');




% hier wird das Positionsingrement berechnet

ing_Pos(1) = ( Pos(1) - oldPos(1) ) /timestep;
ing_Pos(2) = ( Pos(2) - oldPos(2) )/timestep;
ing_Pos(3) = ( Pos(3) - oldPos(3) )/timestep;

ing_TaskAng(1) =( TaskAng(1) - oldTaskAng(1) )/timestep;
ing_TaskAng(2) =( TaskAng(2) - oldTaskAng(2) )/timestep;
ing_TaskAng(3) =( TaskAng(3) - oldTaskAng(3) )/timestep;
ing_TaskAng(4) =( TaskAng(4) - oldTaskAng(4) )/timestep;

 Pos=oldPos;
TaskAng=oldTaskAng;

tmp_Pos(1) = oldPos(1);
tmp_Pos(2) = oldPos(2);
tmp_Pos(3) = oldPos(3);


tmp_TaskAng(1) = oldTaskAng(1);
tmp_TaskAng(2) = oldTaskAng(2);
tmp_TaskAng(3) = oldTaskAng(3);
tmp_TaskAng(4) = oldTaskAng(4);

A=get(ghandle.figure1,'UserData');

for l=1:timestep

    TaskAng(1)  =  TaskAng(1)  +  ing_TaskAng(1);
    TaskAng(2)  =  TaskAng(2)  +  ing_TaskAng(2);
    TaskAng(3)  =  TaskAng(3)  +  ing_TaskAng(3);
    TaskAng(4)  =  TaskAng(4)  +  ing_TaskAng(4);

    Pos(1)    =   Pos(1)   +    ing_Pos(1);
    Pos(2)    =   Pos(2)   +    ing_Pos(2);
    Pos(3)    =   Pos(3)   +    ing_Pos(3);




% Orientation of the robot head
    [PH,TH,R] = cart2sph(Pos(1),Pos(2),Pos(3)-550);
    Angle(1)=PH*rad2deg-90;
    Angle(2)=-TH*rad2deg;

    
    if bodyV==1
        TaskAng(4)=PH*rad2deg-90;
        if TaskAng(4)< -40
            TaskAng(4)=-40;
        end;

        Angle(3)=TaskAng(4);


        boxBody=findobj(gcbf,'Tag','BodyText');
        set(boxBody,'String',sprintf('%3.2f',TaskAng(4)));
        SlBodyHdl=findobj(gcbf,'Tag','SlBody');
        set(SlBodyHdl,'Value',TaskAng(4));
    end;


    [Angle(4),Angle(5),Angle(6),Angle(7),Angle(8),Angle(9),Angle(10)]= ...
        inv_kin8(Pos(1),Pos(2),Pos(3),TaskAng(1),TaskAng(2),TaskAng(3), ...
        TaskAng(4));
    
    Angle(10)=Angle(10)+deg2rad*Gamma;
    Angle(11)=0;

moveRobot(A.arm,A.kopf,A.Trafo,A.static,A.handl,Angle);

end;%%for l=1:timestep

oldTaskAng = TaskAng;
oldPos    = Pos;
