function[labelString,tickStep]=tickLabel(min,max,step,l_step)

  %Produces a stringmatrix for Ticklabeling. Step defines the Tickstep, which defines also the gridstep and 
  %l_step defines the ticks which will be labeled.
  %The outputstringmatrix have to be used with the set command.
  
  %Example: Label=tickLabel(1,100,1,10);set(gca,'Xticklabel',Label,'Xtick',tickStep);
  %This Example produces an axis with tickstep=1 whereas every 10th tick is labeleb by an number

ticknumber=  (abs(min)+abs(max))/step;
minStore=min;  
  
for i=1:ticknumber+1
    if  mod(min,l_step)==0
      labelString(i)={num2str(min)};
    else
      labelString(i)={' '};
    end;
   min=min+step;    
end;

%tickStep=0:ticknumber;
%tickStep=min:step:ticknumber;
tickStep=minStore:step:max;

% set(gca,'Xticklabel',xlabelString,'Xtick',xtick,'Xlim',[-pi pi]);